SoundbankReader (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.sound.midi.spi, class: SoundbankReader
Keywords: javax.sound.midi.spi.SoundbankReader class

# Class SoundbankReader

java.lang.Object
javax.sound.midi.spi.SoundbankReader

public abstract class SoundbankReader extends Object
A `SoundbankReader` supplies soundbank file-reading services. Concrete subclasses of `SoundbankReader` parse a given soundbank file, producing a `Soundbank` object that can be loaded into a `Synthesizer`.

Since:
  1.3

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `SoundbankReader()`
  Constructor for subclasses to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract Soundbank`
  `getSoundbank(File file)`
  Obtains a soundbank object from the `File` provided.
  `abstract Soundbank`
  `getSoundbank(InputStream stream)`
  Obtains a soundbank object from the `InputStream` provided.
  `abstract Soundbank`
  `getSoundbank(URL url)`
  Obtains a soundbank object from the `URL` provided.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### SoundbankReader

    protected SoundbankReader()
    Constructor for subclasses to call.

- ## Method Details

  - ### getSoundbank

    public abstract Soundbank getSoundbank(URL url) throws InvalidMidiDataException, IOException
    Obtains a soundbank object from the `URL` provided.
    Parameters:
      `url` - `URL` representing the soundbank
    Returns:
      soundbank object
    Throws:
      `InvalidMidiDataException` - if the `URL` does not point to valid MIDI soundbank data recognized by this soundbank reader
      `IOException` - if an I/O error occurs
      `NullPointerException` - if `url` is `null`

  - ### getSoundbank

    public abstract Soundbank getSoundbank(InputStream stream) throws InvalidMidiDataException, IOException
    Obtains a soundbank object from the `InputStream` provided.
    Parameters:
      `stream` - `InputStream` representing the soundbank
    Returns:
      soundbank object
    Throws:
      `InvalidMidiDataException` - if the stream does not point to valid MIDI soundbank data recognized by this soundbank reader
      `IOException` - if an I/O error occurs
      `NullPointerException` - if `stream` is `null`

  - ### getSoundbank

    public abstract Soundbank getSoundbank(File file) throws InvalidMidiDataException, IOException
    Obtains a soundbank object from the `File` provided.
    Parameters:
      `file` - the `File` representing the soundbank
    Returns:
      soundbank object
    Throws:
      `InvalidMidiDataException` - if the file does not point to valid MIDI soundbank data recognized by this soundbank reader
      `IOException` - if an I/O error occurs
      `NullPointerException` - if `file` is `null`